;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; From C.A.T.S. v06n04
;
; WRx16 Part 2 by Wilf Rigter and Fred Nachbaur
; continued from the July 1988 issue to be con-
; cluded in the September newsletter.
;
; Originally printed in the ZX-Appeal, Vancouver
; Sinclair Users Group, April and May, 1988
;================================
; Listing 1:
;
; WRx16 CORE V2.1, CODE DISASSEMBLY
;
; NOTE: Listing 2 The MC loader program omitted
: 
;================================

ORG 4082

;================================
;DUMMY DISPLAY FILE
;================================
@DUMY
	LD R,A     		;Load R register
	00 00 00 00		;32 bytes of 8 pixels
	00 00 00 00
	00 00 00 00
	00 00 00 00
	00 00 00 00
	00 00 00 00
	00 00 00 00
	00 00 00 00
	JP (IX)    		;Return to HR
;================================
; DRIVER CODE
;================================
@DPLY
	DI 
	LD A,07 		;Delay counter
	LD B,A 
@DP0
	NOP 
	DJNZ DP0		;Delay
	ADD A,EF 		;239
@DPA
	INC A 
	JR NZ DPA
	LD B,80 
	LD DE,0020 
	LD HL,2000 		;HRDFile
	LD IX,DP1
	JR DP2
@DP1
	LD DE,0020 
	DEC B 
	JP Z DP3
	ADD HL,DE 
@DP2
	LD A,H			;Get HFILE address MSB
	LD I,A			;Load MSB into I register
	LD A,L			;Get HFILE address LSB
	JP C082			;Jump to LBUF+8000 to start ULA
@DP3
	SBC HL,DE 
	SBC HL,DE 
	INC HL 
	LD HL,(400C)		;Get DFile
	LD DE,82F7 
	ADD HL,DE 
	LD A,1E 
	LD I,A 
	LD A,F5 		;245
	LD BC,0207 
	CALL 02B5		;Display-5
	CALL 0292		;Display-3
	CALL 0220		;PushReg
	LD IX,DPLY		;Load the HR vector
	JP 02A4			;PopReg2, return to application program
@HRES
	LD IX,DPLY
	RET
@NRML
	LD A,1E
	LD I,A
	LD IX,0281		;R-IX-1, Video-1 routine
	RET
	NOP 
	NOP 