;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; From C.A.T.S. v06n04
;
; Listing 3:
;
; BI-PLOT M.L. routine
;================================
; Modified WRX16 video driver
;================================
@DPLY				;40A6/16550
	DI
;TILO 
	LD A,07 		;Delay counter
;TILO
	LD B,A 
@DP0
	NOP 
	DJNZ DP0		;Delay
;TILO
	ADD A,F2 		;242
@DPA
	INC A 
	JR NZ DPA
;40B2
	LD B,80 		;128 hi-res lines
;DELY
	LD DE,0020 
	LD HL,2000 		;HRDFile-1
;40BA
	LD A,(4034)		;Get FRAMES
	AND 01			;LD A,00 or LD A,01 
	RLA 
	RLA 
	RLA 
;Mx16
	RLA 
	ADD A,H 
	LD H,A 
;40C5, DELY
	NOP 
	LD IX,DP1
	JR DP2
@DP1
	LD DE,0020 
	DEC B 
	JP Z DP3
	ADD HL,DE 
@DP2
	LD A,H			;Get HFILE address MSB
	LD I,A			;Load MSB into I register
	LD A,L			;Get HFILE address LSB
	JP C082			;Jump to LBUF+8000 to start ULA
@DP3
	SBC HL,DE 
	SBC HL,DE 
	INC HL 
	LD HL,(400C)		;Get DFile
;40E3
	LD DE,8231 		;8000+offset
	ADD HL,DE 
	LD A,1E 
	LD I,A 
	LD A,F5 		;245
;40ED
	LD BC,0807		;B=Lo-res rows-1 
	CALL 02B5		;Display-5
	CALL 0292		;Display-3
	CALL 0220		;PushReg
	LD IX,DPLY		;Load the HR vector
	JP 02A4			;PopReg2, return to application program
	NOP 
	NOP 